/*
 * Copyright (C) 2013 by the University of Southern California
 * $Id$
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License,
 * version 2, as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
 *
 */
#ifndef UTILITY_H 
#define UTILITY_H 1

/*
 * some utility functions 
 */

#include <list>
#include <map>
#include <set>
#include <string>
#include <vector>
#include <numeric>
#include <algorithm>
#include <unistd.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include <resolv.h>
#include <arpa/nameser.h>
#include <netdb.h>

#include "dns_header.h"
#include "types.h"



using namespace std;
void Splitstring(char* cStr, char* cDelim, vector<string> &sItemVec);
double compute_median(vector<unsigned long>& arr);
double compute_mean(vector<unsigned long>& arr);

void ChangetoDnsNameFormat (unsigned char*,unsigned char*);
unsigned char* ReadName (unsigned char*,unsigned char*,int*);

unsigned short format_edns_query(unsigned char* buf, unsigned char* host, int qtype, int qclass, int type, unsigned short msgid, int padding);
unsigned short format_dns_query(unsigned char* buf, unsigned short &qlen, unsigned char* host, int query_type, int query_class, int type, unsigned short msgid, int padding);

//tcp checksum and ip checksum function
unsigned short in_cksum_tcp(int src, int dst, unsigned short *addr, int len);
unsigned short in_cksum(unsigned short *addr, int len);

//parse DNS packets
void print_section(ns_msg handle, int count, ns_sect sec_t, const char* sec_name);
void print_dns_msg(unsigned char* msg, int msg_len);
unsigned short get_dns_msg_id(unsigned char* msg, int msg_len);
bool is_tls_set (unsigned char* msg, int msg_len);


bool read_dnslist(char* fn, vector<string>& dns_list);
void generate_uniq_random(vector<string> &dns_list, int num);
#endif
